/*
 *  The Merge Sort
 */

#define SIZE 1000000
#define Ptint_Status 0

//range of elements in array
#define MAX 100
#define MIN 1

#include <stdlib.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

//prototypes
void print_arr(int *);
void merge_sort(int *arr, int left, int right);
void merge(int *arr, int mid, int left, int right);

int main (void) {

	//seed the random function
	srand (0);
	//srand( time(NULL) );

	int arr[SIZE];
	int counter;

	//init the array
	for( counter = 0; counter < SIZE; counter++) {
		arr[counter] = (rand() % MAX) + MIN;
	}

	//print the unsorted array
	if (Ptint_Status)
		print_arr(arr);

	//start timing
	clock_t start = clock();

	/*** SORTING ***/
	merge_sort(arr, 0, SIZE-1);

	//stop timing
	clock_t stop = clock();

	//print the sorted array
	if (Ptint_Status)
		print_arr(arr);


	//calculate and print the execution time in miliseconds
	double time = (double)(stop - start) * 1000 / CLOCKS_PER_SEC;
	printf("\n%f ms\n", time);

	return 0;
}

void print_arr (int *arr) {
	int counter;
	for(counter = 0; counter < SIZE; counter++) {
		printf("%d ,", arr[counter]);
	}
	printf("\n");
}

void merge_sort(int *arr, int left, int right) {
	if(left < right) {
		int mid = (left + right)/2;
		merge_sort(arr, left, mid);
		merge_sort(arr, mid+1, right);
		merge(arr, mid, left, right);
	}
}

void merge(int *arr, int mid, int left, int right) {
	int i, j, k;

	//size of left
	int sol = mid - left + 1;
	//size of right
	int sor = right - mid;

	//copy the left side
	int L[sol];
	for(i = 0; i < sol; i++)
		L[i] = arr[left + i];

	//copy the right side
	int R[sor];
	for(j = 0; j < sor; j++)
		R[j] = arr[mid + 1 + j];

	i = 0;
	j = 0;
	k = left;

	//push the elements from copys to the main array in sorted mode
	while(i < sol && j < sor) {
		if(L[i] <= R[j]) {
			arr[k] = L[i];
			i++;
		}
		else {
			arr[k] = R[j];
			j++;
		}
		k++;
	}

	//push the remain elements of left side
	while(i < sol) {
		arr[k] = L[i];
		i++;
		k++;
	}

	//push the remain elements of right side
	while(j < sor) {
		arr[k] = R[j];
		j++;
		k++;
	}
}
